import React from 'react'
import { compose } from 'redux'
import { connect } from 'react-redux'
import { v1 } from 'api'
import Helmet from 'react-helmet'
import { Button, ButtonGroup } from 'react-bootstrap';
import { bindRoutineCreators } from 'actions'
import { injectReducer, injectSagas } from 'utils/async'
import { InfoBox, PageContent } from 'components'
import { Steps } from 'intro.js-react';
import 'intro.js/introjs.css';
import { TrainStatus, TrainLogs, Tensorboard } from 'comps/train/components'
import { train } from 'comps/train/actions'

class Train extends React.Component {

  constructor(props) {
    super(props);
    this.state = {
      stepsEnabled: true,
      initialStep: 0,
      steps: [
        {
          element: '.train-page',
          intro: 'This page allows to start a training.',
        },
        {
          element: '.button-primary',
          intro: 'Pressing the button starts training.',
        },
        {
          element: '.TrainLogs',
          intro: 'Logs generated by training will be showed here.',
        },
      ],
    }
  }


  render() {
    const { isLoaded, error, pristine, submitting } = this.props
    if (!isLoaded) {
      return null
    }
    const { stepsEnabled, steps, initialStep } = this.state
    return (
      <PageContent className='train-page'>
        <Steps
          enabled={stepsEnabled}
          steps={steps}
          initialStep={initialStep}
          onExit={() => {
            this.setState(() => ({ stepsEnabled: false }));
          }}
        />
        <Helmet>
          <title>Train</title>
        </Helmet>
        <h1>Train!</h1>
        <div className="row">
          <button type="submit"
            className="button-primary"
            onClick={(e) => {
              this.props.train.trigger({})
            }}
            disabled={pristine || submitting}
          >
            {submitting ? 'Training...' : 'Train'}
          </button>
        </div>
        <Tensorboard />
        <TrainStatus />
        <TrainLogs />
      </PageContent>)
  }
}

const withConnect = connect(
  (state) => {
    const isLoaded = true
    return {
      isLoaded
    }
  },
  (dispatch) => bindRoutineCreators({ train }, dispatch),
)


const withSaga = injectSagas(require('comps/train/sagas/train'))

export default compose(
  withConnect,
  withSaga,
)(Train)
